var XPUB = XPUB || {
	ready : function() {
		if (PubCoder.isQuickPreview) {
			$(window).trigger(PubCoder.Events.PagePlay);
		}
	},

	callNative : function (methodName, methodParameters) {
		if (PubCoder.isQuickPreview) {
			PubCoder.call(methodName, methodParameters);
		}
	},

	openUrl : function (url, openInBrowser) {
		if (PubCoder.isQuickPreview) {
			if (openInBrowser) {
				window.open(url);
			} else {
				window.location = url;
			}
		}
	},
	
	openMenu : function() {
		if (PubCoder.isQuickPreview) {
			XPUB.callNative('openIndex');
		}
	},

	playAudio : function(url, playFromBeginning, objectIdInPage) {
		if (PubCoder.isQuickPreview) {
			$("#"+objectIdInPage).trigger("ended");
		}
	},
	
	openLocalizationsMenu : function() {
		if (PubCoder.isQuickPreview) {
			XPUB.callNative('openLocalizations');
		}
	},

	startStopReadAloud : function(event) {
		if (PubCoder.isQuickPreview) {
			XPUB.callNative('toggleReadAloud');
		}
	},

	toggleSoundtrack : function(event) {
		if (PubCoder.isQuickPreview) {
			XPUB.callNative('toggleSoundtrack');
		}
	},
	
	startSoundtrack : function(event) {
		if (PubCoder.isQuickPreview) {
			XPUB.callNative('startSoundtrack');
		}
	},
	
	stopSoundtrack : function(event) {
		if (PubCoder.isQuickPreview) {
			XPUB.callNative('stopSoundtrack');
		}
	},
	
	close : function() {
		if (PubCoder.isQuickPreview) {
			XPUB.callNative('closeReader');
		}
	},

	getOrientation : function () { return null; },

	sendMail : function(recipient, subject, content) {},
	takePhoto : function() {},
	pickPhoto : function() {},
	scanQr : function() {},
};



window.ondevicemotion = function(e) {
	if (!PubCoder.Accelerometer.Enabled) return; // do nothing, ondevicemotion is disabled, probably by Pubcoder Quick Preview Motion Simulator
	
	var orientation = window.orientation;
	if (window.XPUB != undefined) orientation = window.XPUB.getOrientation();
	var orientationName = "";
	switch (orientation) {
		case 0:
			orientationName = 'portraitButtonBottom';
			break; 
		case 90:
			orientationName = 'landscapeButtonRight';
			break;
		case -90: 
			orientationName = 'landscapeButtonLeft';
			break;
		case 180:
			orientationName = 'portraitButtonTop';
			break;
	}
	
	var dx = 0;
	var dy = 0;
	switch (orientationName) {
		case 'landscapeButtonLeft':
			dx = e.accelerationIncludingGravity.x;
			dy = e.accelerationIncludingGravity.y;
			break;
		case 'portraitButtonBottom':
				dx = -e.accelerationIncludingGravity.y;  
				dy = e.accelerationIncludingGravity.x;
			break;
		case 'landscapeButtonRight':
			dx = -e.accelerationIncludingGravity.x;  
			dy = -e.accelerationIncludingGravity.y;
			break;
		case 'portraitButtonTop':
			dx = e.accelerationIncludingGravity.y;  
			dy = -e.accelerationIncludingGravity.x;
				break;
	}
	// console.log(orientation + " => " + orientationName);
	if (PubCoder.isAndroid) {
		dx = -dx;
		dy = -dy;
	}
	PubCoder.Accelerometer.X = dx;
	PubCoder.Accelerometer.Y = dy;
	window.aigX = dx;  
	window.aigY = dy;

	if (PubCoder.isQuickPreview) {
		XPUB.callNative('deviceMoved', [PubCoder.Accelerometer.X, PubCoder.Accelerometer.Y]);
	}
}

$(window).load(function () {
	if (PubCoder.isQuickPreview) {
		$(window).trigger(PubCoder.Events.PageLoad);
	}
});